PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | Static Public Member Functions | Protected Attributes | List of all members
XMPP::IQ Class Reference

`#include <xmpp.h>`

Inheritance diagram for XMPP::IQ:
[legend]
Collaboration diagram for XMPP::IQ:
[legend]

## Public Types
enum | IQType { Get, Set, Result, Error, Unknown = 999 }

## Public Member Functions
| IQ (IQType type, PXMLElement *body=0)
| IQ (PXML &pdu)
| IQ (PXML *pdu)
| ~IQ ()
virtual PBoolean | IsValid () const
void | SetProcessed ()
    This method signals that the message was taken care of
If the stream handler, after firing all the notifiers finds that an iq set/get pdu has not being processed, it returns an error to the sender More...
PBoolean | HasBeenProcessed () const
virtual IQType | GetType (PString *typeName=0) const
virtual PXMLElement * | GetBody ()
virtual void | SetType (IQType type)
virtual void | SetType (const PString &type)
virtual void | SetBody (PXMLElement *body)
virtual IQ * | GetOriginalMessage () const
virtual void | SetOriginalMessage (IQ *iq)
virtual IQ * | BuildResult () const
    Creates a new response iq for this message (that must
be of the set/get type!) More...
virtual IQ * | BuildError (const PString &type, const PString &code) const
| Creates an error response for this message. More...
virtual PNotifierList | GetResponseHandlers ()
Public Member Functions inherited from XMPP::Stanza
virtual PString | GetID () const
virtual PString | GetFrom () const
virtual PString | GetTo () const
virtual void | SetID (const PString &id)
virtual void | SetFrom (const PString &from)
virtual void | SetTo (const PString &to)
virtual PXMLElement * | GetElement (const PString &name, PINDEX i=0)
virtual void | AddElement (PXMLElement *elem)
Public Member Functions inherited from PXML
| PXML (Options options=NoOptions, const char *noIndentElements=NULL)
| PXML (const PXML &xml)
| ~PXML ()
bool | IsLoaded () const
bool | IsDirty () const
bool | Load (const PString &data, Options options=NoOptions)
bool | LoadFile (const PFilePath &fn, Options options=NoOptions)
virtual void | OnLoaded ()
bool | Save (Options options=NoOptions)
PString | AsString (Options options=NoOptions)
bool | SaveFile (const PFilePath &fn, Options options=NoOptions)
void | RemoveAll ()
PBoolean | IsNoIndentElement (const PString &elementName) const
PString | AsString () const
void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...
PXMLElement * | GetElement (const PCaselessString &name, const PCaselessString &attr, const PString &attrval) const
PXMLElement * | GetElement (const PCaselessString &name, PINDEX idx=0) const
PXMLElement * | GetElement (PINDEX idx) const
PINDEX | GetNumElements () const
PXMLElement * | GetRootElement () const
PXMLElement * | SetRootElement (PXMLElement *p)
PXMLElement * | SetRootElement (const PString &documentType)
bool | RemoveElement (PINDEX idx)
PCaselessString | GetDocumentType () const
bool | Validate (const ValidationInfo *validator)
bool | ValidateElements (ValidationContext &context, PXMLElement *baseElement, const ValidationInfo *elements)
bool | ValidateElement (ValidationContext &context, PXMLElement *element, const ValidationInfo *elements)
bool | LoadAndValidate (const PString &body, const PXML::ValidationInfo *validator, PString &error, Options options=NoOptions)
PString | GetErrorString () const
unsigned | GetErrorColumn () const
unsigned | GetErrorLine () const
PString | GetDocType () const
void | SetDocType (const PString &v)
PMutex & | GetMutex ()
Public Member Functions inherited from PXMLBase
| P_DECLARE_BITWISE_ENUM_EX (Options, 6,(NoOptions, Indent, NewLineAfterElement, NoIgnoreWhiteSpace, CloseExtended, WithNS, FragmentOnly), AllOptions=(1<<(6+1))-1)
| PXMLBase (Options opts=NoOptions)
void | SetOptions (Options opts)
Options | GetOptions () const
void | SetMaxEntityLength (unsigned len)
unsigned | GetMaxEntityLength () const
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...

## Static Public Member Functions
static const PCaselessString & | TypeTag ()
| Various constant strings. More...
static PBoolean | IsValid (const PXML *pdu)
Static Public Member Functions inherited from XMPP::Stanza
static const PCaselessString & | IDTag ()
| Various constant strings. More...
static const PCaselessString & | FromTag ()
static const PCaselessString & | ToTag ()
static PString | GenerateID ()
Static Public Member Functions inherited from PXML
static PString | CreateStartTag (const PString &text)
static PString | CreateEndTag (const PString &text)
static PString | CreateTagNoData (const PString &text)
static PString | CreateTag (const PString &text, const PString &data)
static PString | EscapeSpecialChars (const PString &string)

## Protected Attributes
PBoolean | m_Processed
IQ * | m_OriginalIQ
PNotifierList | m_ResponseHandlers

## Additional Inherited Members
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Friends inherited from PObject

## Member Enumeration Documentation

enum XMPP::IQ::IQType

Enumerator
Get |
Set |
Result |
Error |
Unknown |

## Constructor & Destructor Documentation

XMPP::IQ::IQ | ( | IQType | type,
|  | PXMLElement * | body = `0`
| ) |  |

XMPP::IQ::IQ | ( | PXML & | pdu | ) |

XMPP::IQ::IQ | ( | PXML * | pdu | ) |

XMPP::IQ::~IQ | ( |  | ) |

## Member Function Documentation

virtual IQ* XMPP::IQ::BuildError | ( | const PString & | type,
|  | const PString & | code
| ) |  | const
| virtual

Creates an error response for this message.

virtual IQ* XMPP::IQ::BuildResult | ( |  | ) | const
| virtual

    Creates a new response iq for this message (that must

be of the set/get type!)

virtual PXMLElement* XMPP::IQ::GetBody | ( |  | ) |
| virtual

virtual IQ* XMPP::IQ::GetOriginalMessage | ( |  | ) | const
| inline virtual

References m_OriginalIQ.

virtual PNotifierList XMPP::IQ::GetResponseHandlers | ( |  | ) |
| inline virtual

References m_ResponseHandlers.

virtual IQType XMPP::IQ::GetType | ( | PString * | typeName = `0` | ) | const
| virtual

PBoolean XMPP::IQ::HasBeenProcessed | ( |  | ) | const
| inline

References m_Processed.

virtual PBoolean XMPP::IQ::IsValid | ( |  | ) | const
| virtual

Implements XMPP::Stanza.

static PBoolean XMPP::IQ::IsValid | ( | const PXML * | pdu | ) |
| static

virtual void XMPP::IQ::SetBody | ( | PXMLElement * | body | ) |
| virtual

virtual void XMPP::IQ::SetOriginalMessage | ( | IQ * | iq | ) |
| virtual

void XMPP::IQ::SetProcessed | ( |  | ) |
| inline

    This method signals that the message was taken care of

If the stream handler, after firing all the notifiers finds that an iq set/get pdu has not being processed, it returns an error to the sender

References m_Processed.

virtual void XMPP::IQ::SetType | ( | IQType | type | ) |
| virtual

virtual void XMPP::IQ::SetType | ( | const PString & | type | ) |
| virtual

static const PCaselessString& XMPP::IQ::TypeTag | ( |  | ) |
| static

Various constant strings.

## Member Data Documentation

IQ* XMPP::IQ::m_OriginalIQ
| protected

Referenced by GetOriginalMessage().

PBoolean XMPP::IQ::m_Processed
| protected

Referenced by HasBeenProcessed(), and SetProcessed().

PNotifierList XMPP::IQ::m_ResponseHandlers
| protected

Referenced by GetResponseHandlers().

The documentation for this class was generated from the following file:

- xmpp.h